<?php
list($category, $attr, $table, $create) = getInfoAttr();

$config = array
(
    # 表名
    'name' => 'info_attr' . $table,
    # 显示给用户看的名称
    'lang' => '属性规格',
    'order' => 100,
    'menu' => false,
    'create' => $create,
    'attr' => $attr,
    'auto' => 10000000,

    'end' => array
    (
        'insert' => 'attr/lib/manage.update',
        'update' => 'attr/lib/manage.update',
    ),

    # 数据结构 不同的字段放这里
    'struct' => array
    (
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'update'    => 'hidden',
            'value'     => Dever::input('where_id')
            //'list'        => true,
        ),

        'info_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '商品',
            'default'   => '',
            'desc'      => '商品',
            'match'     => 'is_numeric',
            'update'    => 'hidden',
            'value'     => Dever::input('search_option_info_id')
        ),

        'category'      => array
        (
            'type'      => 'varchar-500',
            'name'      => '分类-直接继承主表的分类',
            'default'   => '',
            'desc'      => '分类',
            'match'     => 'is_string',
            'update'    => 'hidden',
            'value'     => $category
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '数据状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),

        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '发布时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            //'list'        => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    # 索引
    'index' => array
    (
        1 => array
        (
            'search' => 'info_id',
        ),
        
        # 版本号 更改版本号会更新当前表的索引
        'version' => 1,
    ),
    
    # 管理功能
    'manage' => array
    (

    ),

    # request 请求接口定义
    'request' => array
    (
        # 分页
        'getPageAll' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'audit' => array('yes-t_2.audit', 2),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                //'status' => 1,
                //'poster_pay_type' => array('yes-t_2.poster_pay_type', 2),
                'state' => array('yes-t_2.state', 1),
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'res/info',
                    'type' => 'left join',
                    'on' => array('info_id','id'),
                    'col' => 'info_id',
                ),
            ),
            'type' => 'all',
            'order' => array('reorder' => 'desc', 't_1.id' => 'desc'),
            'page' => array(10, 'list'),
            'col' => '*',
        ),
    ),
);


# 属性完全自定义吧。这种情况用dever就是方便了。其他框架都需要自己实现
Dever::load('attr/api')->setDatabaseConfig($attr, $config);

return $config;