<?php

$type = Dever::db('attr/info')->config['sell_type'];
$config = array
(
    # 表名
    'name' => 'info_sku',
    # 显示给用户看的名称
    'lang' => '商品价格设置',
    'order' => 200,
    'menu' => false,

    # 数据结构 不同的字段放这里
    'struct' => array
    (
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            //'list'        => true,
        ),

        'info_id'       => array
        (
            'type'      => 'int-11',
            'name'      => '商品ID',
            'default'   => '',
            'desc'      => '商品ID',
            'match'     => 'is_numeric',
            'update'    => 'text',
            'list'      => true,
        ),

        'key'       => array
        (
            'type'      => 'varchar-100',
            'name'      => '属性标识',
            'default'   => '-1',
            'desc'      => '属性标识',
            'match'     => 'is_string',
            'update'    => 'text',
        ),

        'attr'      => array
        (
            'type'      => 'text-255',
            'name'      => '属性组合规则',
            'default'   => '',
            'desc'      => '属性组合规则',
            'match'     => 'is_string',
            'update'    => 'textarea',
            'list'      => true,
        ),

        'type'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '属性类型',
            'default'   => '1',
            'desc'      => '属性类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $type,
        ),

        'price'     => array
        (
            'type'      => 'varchar-100',
            'name'      => '销售价',
            'default'   => '',
            'desc'      => '销售价',
            'match'     => 'option',
            'update'    => 'text',
            'list'      => true,
        ),

        's_price'       => array
        (
            'type'      => 'varchar-100',
            'name'      => '市场价',
            'default'   => '',
            'desc'      => '市场价',
            'match'     => 'option',
            'update'    => 'text',
            'list'      => true,
        ),

        'f_price'       => array
        (
            'type'      => 'varchar-100',
            'name'      => '采购价',
            'default'   => '',
            'desc'      => '采购价',
            'match'     => 'option',
            'update'    => 'text',
            'list'      => true,
        ),

        'min'       => array
        (
            'type'      => 'int-11',
            'name'      => '起购数',
            'default'   => '0',
            'desc'      => '起购数',
            'match'     => 'is_string',
            'update'    => 'text',
            'list'      => true,
        ),

        'num'       => array
        (
            'type'      => 'int-11',
            'name'      => '库存',
            'default'   => '',
            'desc'      => '库存',
            'match'     => 'is_string',
            'update'    => 'text',
            'list'      => true,
        ),

        'sell_num'      => array
        (
            'type'      => 'int-11',
            'name'      => '销量',
            'default'   => '0',
            'desc'      => '请填写销量',
            'match'     => 'option',
            'search'    => 'order',
            'list'      => true,
        ),

        'reorder'       => array
        (
            'type'      => 'int-11',
            'name'      => '排序-数值越大越靠前，相当于置顶',
            'default'   => '1',
            'desc'      => '请输入排序',
            'match'     => 'option',
            //'update'  => 'text',
            'search'    => 'order',
            'list'      => true,
            'order'     => 'desc',
            'edit'      => true,
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '数据状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),

        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '发布时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            //'search'  => 'date',
            //'list'        => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'alter' => array
    (
        2 => array
        (
            array('update', 'price', 'price', 'varchar-100 0 销售价'),
            array('update', 's_price', 's_price', 'varchar-100 0 市场价'),
            array('update', 'f_price', 'f_price', 'varchar-100 0 采购价'),
        ),
        'version' => 2,
    ),

    'manage' => array
    (
        'insert' => false,
        'edit' => false,
        'delete' => false,
        'num' => false,
        'page_list_table' => 'sku',

        # 自定义快捷新增和编辑
        'button' => array
        (
            //'自定义属性' => array('fast', 1, 'config&where_id=1'),
        ),
    ),

    # request 请求接口定义
    'request' => array
    (
        # 后台搜索用到 也可以不加，自动生成
        'search' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'ids' => array('yes-id', 'in'),
                'info_id' => 'yes',
                'id' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('reorder' => 'desc', 'id' => 'desc'),
            'limit' => '0,10',
            'col' => 'key as name, id, id as value, "" as selected, "" as disabled|id',
        ),

        # 列表
        'getData' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'info_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'col' => 'id,info_id,`key`,price,s_price,type,min',
        ),

        # 列表
        'getDataByKeys' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'info_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'col' => 'id,info_id,`key`,price,s_price,f_price,min|key',
        ),

        # 获取单条数据
        'getOne' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'info_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'one',
            'col' => 'id,info_id,price,s_price,f_price,min',
        ),

        'getMinOne' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'info_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'one',
            'order' => array('price' => 'asc', 'id' => 'desc'),
            'col' => 'id,info_id,price,s_price,min',
        ),

        'getMaxOne' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'info_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'one',
            'order' => array('price' => 'desc', 'id' => 'desc'),
            'col' => 'id,info_id,price,s_price,min',
        ),

        # 更新售出量
        'updateSell' => array
        (
            'type' => 'update',
            'where' => array
            (
                'id' => 'yes',
            ),
            'set' => array
            (
                'sell_num' => array('yes', '+='),
            ),
        ),
    ),
);

return $config;