<?php

namespace Mshop\Src;

use Dever;
use Mshop\Lib\Core;

class My extends Core
{
    public function home()
    {
        $config = Dever::db('main/manage_config')->find();
        $this->data['config'] = $config;
        $this->data['phone'] = $config['phone'];
        $this->data['user'] = $this->user;
        $this->data['shop'] = $this->shop;
        $this->data['date'] = date('Y-m-d');

        $where['mobile'] = $this->user['mobile'];
        $user = Dever::db('shop/member')->select($where);

        if ($user) {
            $this->data['other_shop'] = array();
            foreach ($user as $k => $v) {
                if ($v['shop_id'] != $this->shop_id) {
                    $shop = Dever::db('shop/info')->getOne($v['shop_id']);
                    if ($shop) {
                        $this->data['other_shop'][] = $shop;
                    }
                }
            }
        }

        return $this->data;
    }

    public function getEdit()
    {
        $this->data['user'] = $this->user;
        $this->data['shop'] = $this->shop;

        return $this->data;
    }

    # 修改门店资料
    public function edit()
    {
        $data = array();
        $name = Dever::input('name');
        if ($name) {
            $data['name'] = $name;
        }
        $lng = Dever::input('lng');
        if ($lng) {
            $data['lng'] = $lng;
        }
        $lat = Dever::input('lat');
        if ($lat) {
            $data['lat'] = $lat;
        }
        $address = Dever::input('address');
        if ($address) {
            $data['address'] = $address;
        }
        $truename = Dever::input('truename');
        if ($truename) {
            $data['truename'] = $name;
        }
        $mobile = Dever::input('mobile');
        if ($mobile) {
            $data['mobile'] = $mobile;
        }
        $open = Dever::input('open');
        if ($open) {
            $data['open'] = $open;
        }
        $method = Dever::input('method');
        if ($method) {
            $data['method'] = $method;
        }
        $worktime = Dever::input('worktime');
        if ($worktime) {
            $data['worktime'] = $worktime;
        }

        if ($data) {
            $data['where_id'] = $this->shop_id;
            Dever::db('shop/info')->update($data);
        }
        

        return 'ok';
    }

    # 员工列表
    public function getUser()
    {
        $where['shop_id'] = $this->shop_id;
        $this->data['user'] = Dever::db('shop/member')->select_page($where);
        $role = Dever::db('shop/member')->config['role'];
        foreach ($this->data['user'] as $k => $v) {
            $v['role_name'] = array();
            $v['role'] = explode(',', $v['role_id']);
            foreach ($role as $k1 => $v1) {
                if (in_array($k1, $v['role'])) {
                    $v['role_name'][] = $v1;
                }
            }
            $this->data['user'][$k]['role_name'] = implode(',', $v['role_name']);
        }

        return $this->data;
    }

    # 添加员工
    public function getEditUser()
    {
        $this->data['role'] = Dever::db('shop/member')->config['role'];

        $id = Dever::input('id');

        if ($id) {
            $this->data['user'] = Dever::db('shop/member')->find($id);
        }

        return $this->data;
    }

    # 编辑员工
    public function upUser()
    {
        $id = Dever::input('id');
        $role = Dever::input('role');
        $avatar = Dever::input('avatar');
        $name = Dever::input('name');
        $mobile = Dever::input('mobile');
        if ($role) {
            $update['role_id'] = $role;
        }
        
        if ($avatar) {
            $update['avatar'] = $avatar;
        }

        if ($name) {
            $update['name'] = $name;
        } else {
            Dever::alert('姓名不能为空');
        }

        if ($mobile) {
            $update['mobile'] = $mobile;
            $check = Dever::db('shop/member')->find(array('mobile' => $mobile, 'shop_id' => $this->shop_id));
            if ($check && $id && $id != $check['id']) {
                Dever::alert('电话已存在');
            } elseif ($check && !$id) {
                Dever::alert('电话已存在');
            }
        } else {
            Dever::alert('电话不能为空');
        }

        $update['shop_id'] = $this->shop_id;

        if ($id) {
            $update['where_id'] = $id;
            Dever::db('shop/member')->update($update);
        } else {
            $id = Dever::db('shop/member')->insert($update);
        }

        return 'ok';
    }

    # 删除员工
    public function delUser()
    {
        $id = Dever::input('id');
        $info = Dever::db('shop/member')->find($id);
        if ($info && $info['shop_id'] == $this->shop_id) {
            Dever::db('shop/member')->delete($id);
        } else {
            Dever::alert('您没有权限删除');
        }

        return 'ok';
    }

    # 打印机列表
    public function getPrint()
    {
        $where['shop_id'] = $this->shop_id;
        $this->data['print'] = Dever::db('shop/print')->select($where);

        return $this->data;
    }

    # 添加打印机
    public function getEditPrint()
    {
        $id = Dever::input('id');

        if ($id) {
            $this->data['print'] = Dever::db('shop/print')->find($id);
        }

        return $this->data;
    }

    # 编辑打印机
    public function upPrint()
    {
        $id = Dever::input('id');
        $name = Dever::input('name');
        $number = Dever::input('number');
        $key = Dever::input('key');
        $phonenum = Dever::input('phonenum');
        if ($name) {
            $update['name'] = $name;
        } else {
            Dever::alert('名称不能为空');
        }

        if ($number) {
            $update['number'] = $number;
        } else {
            Dever::alert('编号不能为空');
        }

        if ($key) {
            $update['key'] = $key;
        } else {
            Dever::alert('识别码不能为空');
        }

        if ($phonenum) {
            $update['phonenum'] = $phonenum;
        }

        $update['shop_id'] = $this->shop_id;

        if ($id) {
            $update['where_id'] = $id;
            Dever::db('shop/print')->update($update);
        } else {
            $id = Dever::db('shop/print')->insert($update);
        }

        return 'ok';
    }

    # 删除打印机
    public function delPrint()
    {
        $id = Dever::input('id');
        $info = Dever::db('shop/print')->find($id);
        if ($info && $info['shop_id'] == $this->shop_id) {
            Dever::db('shop/print')->update(array('where_id' => $info['id'], 'state' => 2));

            //Dever::load('mshop/lib/feieyun')->del(array($info));
        } else {
            Dever::alert('您没有权限删除');
        }

        return 'ok';
    }

    # 营销活动 优惠券列表
    public function getCoupon()
    {
        $this->data['method'] = Dever::db('goods/coupon')->config['method'];
        $this->data['coupon'] = Dever::db('goods/coupon')->select();

        if ($this->data['coupon']) {
            $this->data['day'] = Dever::db('shop/coupon')->config['time'];
            foreach ($this->data['coupon'] as $k => $v) {
                $this->data['coupon'][$k]['check'] = 1;
                $check = Dever::db('shop/coupon')->find(array('shop_id' => $this->shop_id, 'coupon_id' => $v['id']));
                if ($check) {
                    $this->data['coupon'][$k]['check'] = 2;
                    $this->data['coupon'][$k]['shop'] = $check;
                }
            }
        }
        return $this->data;
    }

    # 营销活动 配置
    public function setCoupon()
    {
        /*
        $coupon_city = Dever::input('coupon_city');

        if ($coupon_city) {
            $update['where_id'] = $this->shop_id;
            $update['coupon_city'] = $coupon_city;
            Dever::db('shop/info')->update($update);
        }
        */
        $coupon = Dever::input('coupon');

        //$coupon[] = array('id' => 1, 'day' => 7, 'method' => 2, 'num' => 10);

        //print_r(Dever::json_encode($coupon));die;

        if ($coupon) {
            $coupon = Dever::json_decode($coupon);
            foreach ($coupon as $k => $v) {
                $info = Dever::db('shop/coupon')->find(array('shop_id' => $this->shop_id, 'coupon_id' => $v['id']));
                $data = array();
                $data['method'] = $v['method'];
                $data['coupon_id'] = $v['id'];
                $data['coupon'] = $v['method'] . ',' . $v['id'];
                $data['day'] = $v['day'];
                $data['num'] = $v['num'];
                if (!$info) {
                    $data['shop_id'] = $this->shop_id;
                    Dever::db('shop/coupon')->insert($data);
                } else {
                    $data['where_id'] = $info['id'];
                    Dever::db('shop/coupon')->update($data);
                }
            }
        }

        return $this->getCoupon();
    }

    # 获取参与活动领取的优惠券
    public function getActCoupon()
    {
        $act_id = Dever::input('act_id', 1);
        $this->data['shop_coupon'] = Dever::load('shop/lib/coupon')->getData($this->shop_id);

        foreach ($this->data['shop_coupon'] as $k => $v) {
            $this->data['shop_coupon'][$k]['info'] = Dever::db('goods/coupon')->find($v['coupon_id']);
            $check = Dever::db('shop/coupon_act')->find(array('shop_id' => $this->shop_id, 'shop_coupon_id' => $v['id'], 'act_id' => $act_id));
            $this->data['shop_coupon'][$k]['check'] = 1;
            if ($check) {
                $this->data['shop_coupon'][$k]['act_coupon'] = $check;
                $this->data['shop_coupon'][$k]['check'] = 2;
            }
        }

        return $this->data;
    }

    # 销售对账单管理
    public function stat_month()
    {
        $this->data['config'] = Dever::db('main/manage_config')->find();
        $where['shop_id'] = $this->shop_id;
        $shop = Dever::db('shop/info')->find($this->shop_id);
        $month = Dever::input('month');
        if ($month) {
            $where['start'] = Dever::maketime($month . '-01 00:00:00');
            $where['end'] = Dever::maketime($month . '-t 23:59:59');
        }
        
        $this->data['data'] = Dever::db('cash/shop')->getAll($where);

        $status = Dever::db('cash/shop')->config['config_status'];

        if ($this->data['data']) {
            foreach ($this->data['data'] as $k => $v) {
                $this->data['data'][$k]['name'] = date('Y年m月', $v['month']);
                $this->data['data'][$k]['start'] = date('Y-m-01', $v['month']);
                $this->data['data'][$k]['end'] = date('Y-m-t', $v['month']);
                $this->data['data'][$k]['status_name'] = $status[$v['shop_status']];
            }
        }

        return $this->data;
    }

    # 确认对账
    public function set_stat_month()
    {
        $id = Dever::input('id');

        $where['id'] = $id;
        $where['shop_id'] = $this->shop_id;
        $info = Dever::db('cash/shop')->find($where);
        if (!$info) {
            Dever::alert('账单不存在');
        }
        if ($info) {
            Dever::db('cash/shop')->update(array('where_id' => $id, 'shop_status' => 2));
        }

        return $this->stat_month();
    }

    # 查看账单详情
    public function stat_month_view()
    {
        $id = Dever::input('id');
        $where['id'] = $id;
        $where['shop_id'] = $this->shop_id;
        $this->data['config'] = Dever::db('main/sell_config')->find();
        $this->data['info'] = Dever::db('cash/shop')->find($where);

        if (!$this->data['info']) {
            Dever::alert('账单不存在');
        }
        $status = Dever::db('cash/shop')->config['config_status'];

        $this->data['info']['name'] = date('Y年m月',  $this->data['info']['month']);
        $this->data['info']['start'] = date('Y-m-01', $this->data['info']['month']);
        $this->data['info']['end'] = date('Y-m-t', $this->data['info']['month']);
        $this->data['info']['status_name'] = $type[$this->data['info']['shop_status']];

        $where = array();
        $where['type'] = 1;
        $where['type_id'] = $this->shop_id;
        $where['start'] = Dever::maketime($this->data['info']['start'] . ' 00:00:00');
        $where['end'] = Dever::maketime($this->data['info']['end'] . ' 23:59:59');
        $where['status'] = 2;
        $this->data['data'] = Dever::db('cash/order')->getAll($where);

        if ($this->data['data']) {
            foreach ($this->data['data'] as $k => $v) {
                $this->data['data'][$k]['status_name'] = '已入账';
                $this->data['data'][$k]['cdate'] = date('Y-m-d H:i', $v['cdate']);
            }
        }

        return $this->data;
    }

    # 门店物料
    public function info()
    {
        $config = Dever::db('main/manage_config')->find();
        $this->data['file'] = $config['file'];
        $param['project'] = 1;
        $param['width'] = 150;
        $param['path'] = 'pages/app/shop/shop';
        $param['send'] = $this->shop_id;
        $this->data['ercode'] = Dever::load('wechat_applet/code')->get($param);
        return $this->data;
    }

}