<?php

$out_type = array
(
    1 => '店铺活动',
    2 => '礼品赠送',
    3 => '保质期到期销毁',
    4 => '库存损毁',
    10 => '其他',
);

$status = array
(
    1 => '待审核',
    2 => '已审核',
    3 => '取消',
);

$shop = function()
{
    $array = array();
    $info = Dever::db('shop/info')->select();
    if($info)
    {
        $array += $info;
    }
    return $array;
};

$store = function()
{
    $array = array();
    $info = Dever::db('store/info')->select();
    if($info)
    {
        $array += $info;
    }
    return $array;
};

# 1是门店 2是仓库
$search = Dever::input('search_option_type', 1);

if ($search == 1) {
    $search_name = '所属门店';
    $search_option = $shop;
    $search_url = 'shop/lib/manage.search';
} elseif ($search == 2) {
    $search_name = '所属仓库';
    $search_option = $store;
    $search_url = 'store/lib/manage.search';
}

return array
(
    # 表名
    'name' => 'out_order',
    # 显示给用户看的名称
    'lang' => '出库订单',
    'order' => 98,
    'config_type' => $out_type,
    'config_status' => $status,
    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            //'list'      => true,
        ), 

        'type'      => array
        (
            'type'      => 'int-11',
            'name'      => '拥有人类型',
            'default'   => '',
            'desc'      => '拥有人类型',
            'search'    => 'hidden',
            'match'     => 'is_numeric',
        ),

        'type_id'      => array
        (
            'type'      => 'int-11',
            'name'      => $search_name,
            'default'   => '',
            'desc'      => '拥有人',
            'match'     => 'is_numeric',
            'search'    => $search == 3 ? '' : 'select',
            'option'    => $search_option,
            //'update_search' => $search_url,
            'list'      => 'Dever::load("shop/lib/manage.buyInfo", "{type}", "{type_id}")',
        ),

        'name'      => array
        (
            'type'      => 'varchar-800',
            'name'      => '订单名称',
            'default'   => '',
            'desc'      => '订单名称',
            'match'     => 'is_string',
            'update'    => 'text',
        ),

        'order_num'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '订单编号',
            'default'   => '',
            'desc'      => '订单编号',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'price'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '价格',
            'default'   => '',
            'desc'      => '价格',
            'match'     => 'option',
            'update'    => 'text',
            'list'      => $search == 1 ? true : false,
        ),

        'num'        => array
        (
            'type'      => 'int-11',
            'name'      => '数量',
            'default'   => '',
            'desc'      => '数量',
            'match'     => 'is_numeric',
            'search'    => 'select',
            'list'        => true,
        ),

        'info'      => array
        (
            'type'      => 'varchar-300',
            'name'      => '订单备注',
            'default'   => '',
            'desc'      => '订单备注',
            'match'     => 'option',
            'update'    => 'textarea',
        ),

        'member_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '操作人',
            'default'   => '',
            'desc'      => '操作人',
            'match'     => 'option',
            //'update'  => 'text',
        ),

        'out_type'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '类型',
            'default'   => '1',
            'desc'      => '类型',
            'match'     => 'is_numeric',
            'option'    => $out_type,
            'search'    => 'select',
            'list'      => true,
        ),

        'status'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '状态',
            'match'     => 'is_numeric',
            'option'    => $status,
            'search'    => 'select',
            'list'      => true,
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '出库时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'search'    => 'date',
            'list'        => 'date("Y-m-d H:i:s", {cdate})',
            //'list'      => 'Dever::load("service/lib/manage.showOrderTime", "{id}")',
        ),
    ),

    'manage' => array
    (
        'delete' => false,
        'edit' => false,
        'insert' => false,

        'button' => array
        (
            //'导出订单' => array('location', 'user/lib/manage.out'),
        ),

        'list_button' => array(
            //'edit' => array('退款', 'status,tk_time,tk_pic,tk_desc,tk_admin', '{status} == 2'),
            //'delete' => array('删除', '', '{status} == 1'),
            'fast_list' => array('查看详情', '"out_order_goods&project=shop&order_id={id}&page_type=1"'),

            'oper'  => array('审核', '"mshop/lib/out.yes?id={type_id}&order_id={id}"', '{status} == 1 && {type} == 2'),
        ),
    ),

    'request' => array
    (
        'getAll' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'order_num' => array('yes', 'like'),
                'type' => 'yes',
                'type_id' => 'yes',
                'out_type' => 'yes',
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'page' => array(10, 'list'),
            'col' => '*',
        ),

        # 获取订单数量
        'getOrderNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'type' => 'yes',
                'type_id' => 'yes',
                'out_type' => 'yes',
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'count',
            'col' => '*',
        ),

        # 获取总金额
        'getCashNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'type' => 'yes',
                'type_id' => 'yes',
                'out_type' => 'yes',
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'one',
            'col' => 'sum(price) as total',
        ),

        # 获取商品数量
        'getGoodsNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'type' => 'yes',
                'type_id' => 'yes',
                'out_type' => 'yes',
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'one',
            'col' => 'sum(num) as total',
        ),
    ),
);
