<?php

$pay_status = Dever::config('base', 'pay')->pay['status'];

$method = array
(
    1 => '自提',
    2 => '外送',
);

$pay_method = array
(
    1 => '平台结算',
    2 => '门店代下单',
    3 => '礼品卡',
);

$pay_type = array
(
    1 => '微信',
    2 => '现金',
);

$status = array
(
    1 => '待支付',
    2 => '待处理',
    3 => '处理中',
    4 => '待收货确认',
    5 => '已完成',
    6 => '已完成（有退款）',
    7 => '已取消',
    8 => '已取消',//已退款
    11 => '已取消',//已过期
);

//1待支付2支付成功3处理中4待确认5已完成6已完成（有退款）7已取消8已退款11已过期

$refund_status = array
(
    1 => '未申请',
    2 => '已申请',
);

$shop = function()
{
    $array = array();
    $info = Dever::db('shop/info')->select();
    if($info)
    {
        $array += $info;
    }
    return $array;
};

return array
(
    # 表名
    'name' => 'sell_order',
    # 显示给用户看的名称
    'lang' => '销售订单',
    'order' => 100,
    'status' => $status,
    'pay_method' => $pay_method,
    'pay_type' => $pay_type,
    'method' => $method,
    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            //'list'      => true,
        ), 

        'shop_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '所属门店',
            'default'   => '',
            'desc'      => '所属门店',
            'match'     => 'is_numeric',
            'search'    => 'select',
            'option'    => $shop,
            'update'    => 'hidden',
            'value'     => Dever::input('search_option_shop_id'),
            'list'      => 'Dever::load("shop/info-one#name", {shop_id})',
        ),

        'uid'       => array
        (
            'type'      => 'int-11',
            'name'      => '购买人名称',
            'default'   => '0',
            'desc'      => '请选择用户',
            'match'     => 'is_numeric',
            'update'    => 'text',
            //'search'  => 'select',
            'search'    => array
            (
                'api' => 'passport/user-select',
                'col' => 'username',
                'result' => 'id',
            ),
            'list'      => 'Dever::load("shop/lib/manage.user", {id})',
        ),

        'mobile'        => array
        (
            'type'      => 'varchar-300',
            'name'      => '下单手机号',
            'default'   => '',
            'desc'      => '手机号',
            'match'     => 'option',
            'search'    => 'fulltext',
            /*
            'search'    => array
            (
                'api' => 'passport/user-select',//接口地址，最好是获取多条数据的地址
                'col' => 'mobile',//要查询的字段
                'result' => 'id',//返回的字段
                'search' => 'uid',//本表的字段，默认为当前的字段
            ),
            */
        ),

        'address_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '送货地址',
            'default'   => '',
            'desc'      => '送货地址',
            'match'     => 'is_numeric',
            //'list'      => 'Dever::load("passport/address-find#address", {address_id})';
        ),

        'invoice_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '发票信息',
            'default'   => '',
            'desc'      => '发票信息',
            'match'     => 'is_numeric',
            //'list'      => 'Dever::load("passport/address-find#address", {address_id})';
        ),

        'name'      => array
        (
            'type'      => 'varchar-800',
            'name'      => '订单名称',
            'default'   => '',
            'desc'      => '订单名称',
            'match'     => 'is_string',
            'update'    => 'text',
        ),

        'order_num'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '订单号',
            'default'   => '',
            'desc'      => '订单号',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'price'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '支付金额',
            'default'   => '0',
            'desc'      => '支付金额',
            'match'     => 'option',
            'update'    => 'text',
            'list'        => true,
        ),

        'num'        => array
        (
            'type'      => 'int-11',
            'name'      => '购买数量',
            'default'   => '',
            'desc'      => '购买数量',
            'match'     => 'is_numeric',
            'search'    => 'select',
            //'list'        => true,
        ),

        'refund_cash'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '退款合计金额',
            'default'   => '0',
            'desc'      => '退款合计金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'refund_status'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '申请退款类型',
            'default'   => '1',
            'desc'      => '申请退款类型',
            'match'     => 'is_numeric',
            'option'    => $refund_status,
            //'search'    => 'select',
        ),

        'kou_cash'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '抹零金额',
            'default'   => '0',
            'desc'      => '抹零金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'ps_cash'      => array
        (
            'type'      => 'varchar-50',
            'name'      => '配送费',
            'default'   => '0',
            'desc'      => '配送费',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'card_code_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '礼品卡id',
            'default'   => '',
            'desc'      => '礼品卡id',
            'match'     => 'option',
        ),

        'coupon_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '门店的优惠券id',
            'default'   => '',
            'desc'      => '门店的优惠券id',
            'match'     => 'option',
        ),

        'user_coupon_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '用户的优惠券id',
            'default'   => '',
            'desc'      => '用户的优惠券id',
            'match'     => 'option',
        ),

        'coupon_cash'      => array
        (
            'type'      => 'varchar-300',
            'name'      => '优惠金额',
            'default'   => '0',
            'desc'      => '优惠金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'method'        => array
        (
            'type'      => 'int-11',
            'name'      => '配送类型',
            'default'   => '1',
            'desc'      => '配送类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $method,
        ),

        'code'        => array
        (
            'type'      => 'varchar-100',
            'name'      => '自提码或者核销码',
            'default'   => '',
            'desc'      => '自提码或者核销码',
            'match'     => 'is_numeric',
        ),

        'pay_method'        => array
        (
            'type'      => 'int-11',
            'name'      => '支付类型',
            'default'   => '1',
            'desc'      => '支付类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $pay_method,
            'list'      => true,
        ),

        'pay_type'        => array
        (
            'type'      => 'int-11',
            'name'      => '支付方式',
            'default'   => '1',
            'desc'      => '支付方式',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $pay_type,
        ),

        'info'      => array
        (
            'type'      => 'varchar-300',
            'name'      => '订单备注',
            'default'   => '',
            'desc'      => '订单备注',
            'match'     => 'option',
            'update'    => 'textarea',
        ),

        'status'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '状态',
            'match'     => 'is_numeric',
            'option'    => $status,
            'search'    => 'select',
            'list'      => true,
        ),

        'fdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '完成时间',
            'default'   => '',
            'match'     => 'is_numeric',
            'desc'      => '',
        ),

        'operdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '操作时间',
            'default'   => '',
            'match'     => 'is_numeric',
            'desc'      => '',
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '下单时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'search'    => 'date',
            'list'        => 'date("Y-m-d H:i:s", {cdate})',
            //'list'      => 'Dever::load("service/lib/manage.showOrderTime", "{id}")',
        ),
    ),

    'manage' => array
    (
        'delete' => false,
        'edit' => false,
        'insert' => false,

        'button' => array
        (
            //'导出订单' => array('location', 'user/lib/manage.out'),
        ),

        'list_button' => array
        (
            //fast_list
            'list' => array('查看详情', '"sell_order_goods&project=shop&order_id={id}&page_type=1"'),

            //'edit' => array('退款', 'status,tk_time,tk_pic,tk_desc,tk_admin,tk_status', '{status} == 6'),
            //'delete' => array('删除', '', '{status} == 1'),
        ),
    ),

    'request' => array
    (
        'getList' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'shop_id' => 'yes',
                'uid' => 'yes',
                'status' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'page' => array(5, 'list'),
            'col' => '*',
        ),

        'getAll' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'uid' => 'yes',
                'name' => array('yes', 'like'),
                'shop_id' => 'yes',
                'mobile' => 'yes',
                'method' => 'yes',
                'pay_method' => 'yes',
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'page' => array(10, 'list'),
            'col' => '*',
        ),

        'getYes' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'shop_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'col' => '*',
        ),

        # 获取提交订单超过12个小时
        'getDataByTime' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'cdate' => array('yes', '>='),
                'status' => 'yes',
                'notice' => 'yes',
                'note' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('cdate' => 'desc'),
            'col' => '*',
        ),

        # 获取1,2
        'getBuy' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'status' => 'yes',
                'shop_id' => 'yes',
                'order_num' => 'yes',
                'uid' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'col' => '*',
        ),

        'getMyAll' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'uid' => 'yes',
                'status' => 'yes',
                'cate_id' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'page' => array(10, 'list'),
            'col' => 'id,order_num,name,buy_num,cdate,cash,shop_id,buy_id',
        ),

        # 删除未支付订单
        'drop' => array
        (
            # 匹配的正则或函数 选填项
            'where' => array
            (
                'time' => array('yes-cdate', '<='),
                'status' => 1,
                'state' => 1,
            ),
            'type' => 'delete',
            'col' => 'id,order_num',
        ),

        # 获取数据
        'getAllByDate' => array
        (
            # 匹配的正则或函数 选填项
            'where' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
            ),
            'type' => 'all',
            'col' => 'id,order_num',
        ),

        # 获取订单数量
        'getOrderNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'shop_id' => 'yes',
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'count',
            'col' => '*',
        ),

        # 获取总金额
        'getCashNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'shop_id' => 'yes',
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'one',
            'col' => 'sum(price-refund_cash) as total',
        ),

        # 获取商品数量
        'getGoodsNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-cdate', '>='),
                'end' => array('yes-cdate', '<='),
                'shop_id' => 'yes',
                'status' => array('yes', 'in'),
                'state' => 1,
            ),
            'type' => 'one',
            'col' => 'sum(num) as total',
        ),
    ),
);
